From ee24bd3a2d76e27d68619773579df4b8674e24c2 Mon Sep 17 00:00:00 2001
From: Thomas JUND <tjund@entrouvert.com>
Date: Wed, 11 Aug 2021 10:28:05 +0200
Subject: [PATCH 02/11] guerande: use combo asset to manage header logo

---
 static/guerande/_custom.scss        |   4 +---
 static/guerande/config.json         |   3 +++
 static/guerande/img/header-logo.png | Bin 14448 -> 0 bytes
 3 files changed, 4 insertions(+), 3 deletions(-)
 delete mode 100644 static/guerande/img/header-logo.png

diff --git a/static/guerande/_custom.scss b/static/guerande/_custom.scss
index c194f757..d5ff8bac 100644
--- a/static/guerande/_custom.scss
+++ b/static/guerande/_custom.scss
@@ -28,8 +28,7 @@ div#header h1#logo {
 		@media screen and (max-width: $nav-mobile-limit) {
 			margin-left: calc(55% - 160px);}
 		a {
-		background: url(img/header-logo.png) top left no-repeat;
-		background-size: contain;
+		background-position: top left;
 		padding-left: 400px;
 		@media screen and (max-width: $nav-mobile-limit) {
 			background-size: 80%;
@@ -37,7 +36,6 @@ div#header h1#logo {
 			padding-left: 300px;
 		}
 		display: block;
-		text-indent: -10000px;
 		min-height: 130px;
 		line-height: 120px;
 	}
diff --git a/static/guerande/config.json b/static/guerande/config.json
index 1f03200f..e024638f 100644
--- a/static/guerande/config.json
+++ b/static/guerande/config.json
@@ -11,6 +11,9 @@
           "name": "En-tête et trois colonnes",
           "template": "combo/page_template_header_3cols.html"
         }
+      },
+      "COMBO_ASSET_SLOTS.update": {
+        "header:logo": { "label": "Têtière : logo" }
       }
     }
   }
diff --git a/static/guerande/img/header-logo.png b/static/guerande/img/header-logo.png
deleted file mode 100644
index cc6bfbb990cd8b48aa5b02e3f6c94e5f184dcde7..0000000000000000000000000000000000000000
GIT binary patch
-- 
2.20.1